/* -*- Javascript -*- */

/* global variables */

var file = null;
var export_filename = 'export_config.csv';
var nb_items = 0;

var names = new Array ('Element list', 'Parameters', 'Description', 'Type', 'Default value');
var vars = new Array ('element_list', 'param', 'desc', 'type', 'default_value');

function add_row (pos, line, isAppend) {
  if (typeof isAppend === 'undefined') isAppend = 1;

  if (line == null)
    line = new Array ();

  var table = document.getElementById ('config');
  if (!table) {
    return {stat: 1, msg: 'can\'t find old table'};
  }

  if (pos < 0) {
    pos = 0;
  } else {
    var ref = document.getElementById ('var_' + pos);
    if (ref) {
      for (var i = 0; i < table.rows.length; i++) {
        if (table.rows[i].id == 'var_' + pos) {
          pos = i + ((isAppend) ? 1 : 0);
          break;
        }
      }
    } else {
      pos = table.rows.length;
    }
  }

  /* create row */
  var row = table.insertRow (pos);
  row.id = 'var_' + nb_items;
  for (var j in vars) {
    var cell = document.createElement ('td');
    cell.setAttribute ('oncontextmenu', 'javascript: show_menu(event, ' + nb_items + ');');
    row.appendChild (cell);

    var input = document.createElement ('input');
    input.type = 'text';
    input.value = (typeof line[j] !== 'undefined') ? line[j] : '';

    /* special */
    switch (j) {
    case '0':
      input.title = 'if empty, only description field is used to create sub-header';
      break;
    case '1':
      input.title = 'if empty, retrieve main value';
      break;
    case '3':
      try {
        input.remove ();
      }
      catch (err) {
        cell.appendChild (input);
        var father = input.parentNode;
        father.removeChild (input);
      }
      input = document.createElement ('select');
      var types = new Array (new Option('Checkbox', 'check'),
                             new Option('Integer', 'integer'),
                             new Option('Float', 'float'),
                             new Option('IP address', 'ip'),
                             new Option('MAC address', 'mac'),
                             new Option('String', 'string', true));
      for (var i in types)
        input.options[input.length] = types[i];
      if (typeof line[j] !== 'undefined')
        for (var i = 0; i < input.options.length; i++)
          if (input.options[i].value == line[j]) {
            input.options[i].selected = true;
            break;
          }
      break;
    }
    cell.className = (j == '3') ? 'fit' : 'expand';
    input.id = vars[j] + '_' + nb_items;
    cell.appendChild (input);
  }

  nb_items++;

  return {stat: 0, msg: (isAppend) ? 'appending new item' : 'inserting new item'};
}

/* delete row */

function delete_row (pos) {

  var stat = 2;
  var msg = 'can\'t find reference';

  var ref = document.getElementById ('var_' + pos);
  if (ref)  {
    var nb = 0;
    for (var i = 0; i < ref.parentNode.rows.length; i++)
      if (ref.parentNode.rows[i].id.match (/var_/))
        nb++;
    if (nb > 1) {
      var father = ref.parentNode;
      father.removeChild (ref);
      stat = 0;
      msg = 'removing current item';
    } else {
      stat = 1;
      msg = 'removing current item';
    }
  }

  return {msg: msg, stat: stat};
}

/* import procedure */

function import_proc (data) {

  /* remove previous table */
  var table = document.getElementById ('config');
  if (!table) {
    update_status ('can\'t find previous table');
    return;
  }
  var father = table.parentNode;
  father.removeChild (table);

  /* save data file*/
  file = data;
  nb_items = 0;

  /* create new table */
  var table = document.createElement ('table');
  table.className = 'table';
  table.id = 'config';
  father.appendChild (table);

  /* create header row */
  var row_header = table.insertRow (0);
  for (var i in names) {
    var cell_header = document.createElement ('th');
    row_header.appendChild (cell_header);
    cell_header.innerHTML = names[i];
    cell_header.className = (i == '3') ? 'fit' : 'expand';
  }

  /* for each line */
  var tab = data.split ('\n');
  for (var i in tab) {

    var line = tab[i].replace (/#.*/, '').split (';');
    if (line.length <= 1)
      continue;

    /* create row */
    add_row (nb_items, line);
  }

  /* table is updated */
  update_status ('import done', 0);
}

/* export raw database */

function export_proc () {

  /* build CSV data */
  var data = '# -*- CSV -*-';

  /* remove previous table */
  var table = document.getElementById ('config');
  if (!table) {
    return;
  }

  for (var i = 0; i < table.rows.length; i++) {
    if (table.rows[i].id == '') continue;
    var line = '';
    for (var j in vars) {
      var id = table.rows[i].id.replace (/var_/, vars[j] + '_');
      var ref = document.getElementById (id);
      var value = (ref) ? get_input_value (ref) : '';
      line += ((j > 0) ? ';' : '') + value;
    }

    data += '\n' + line;
  }

  return data;
}

/* menu function */

function is_last_item () {

  /* count remaining items */
  var nb = 0;
  for (var i = 0; i < nb_items; i++)
    if (document.getElementById ('var_' + i))
      nb++;

  return (nb > 1);
}

menu = new Array (menuCallback ('Append new entry', null, function (id) { return add_row (id, null, true); }),
                  menuCallback ('Insert new entry', null, function (id) { return add_row (id, null, false); }),
                  menuCallback ('Remove current entry', is_last_item, function (id) { return delete_row (id); }));
