/* -*- Javascript -*- */

/* add event action */

function add_event (obj, type, fn) {

  if (obj.attachEvent) {
    obj['e' + type + fn] = fn;
    obj[type + fn] = function () { obj['e' + type + fn] (window.event); };
    obj.attachEvent ('on' + type, obj[type + fn]);
  } else
    obj.addEventListener (type, fn, false);
}

/* check input */

function check_input (event) {

  var ref = event.target;
  if ((!ref) || (typeof ref.regexp === 'undefined'))
    return;

  if (ref.value.match (ref.regexp)) {
    if (typeof ref.style.foregroundColor !== 'undefined')
      ref.style.color = ref.style.foregroundColor;
  } else {
    if (typeof ref.style.foregroundColor === 'undefined')
      ref.style.foregroundColor = ref.style.color;
    ref.style.color = 'red';
  }
}

/* create input */

function create_input (variable, value, type, default_value) {
  if (typeof type === 'undefined') type = 'string';
  if (typeof default_value === 'undefined') default_value = '';

  var input = document.createElement ('input');
  input.type = 'text';
  input.value = value;
  switch (type) {
  case 'check':
    input.type = 'checkbox';
    switch (value) {
    case 'no':
    case 'yes':
      input.answer = new Array ('no', 'yes');
      break;
    case 'NO':
    case 'YES':
      input.answer = new Array ('NO', 'YES');
      break;
    case 'false':
    case 'true':
      input.answer = new Array ('false', 'true');
      break;
    case 'FALSE':
    case 'TRUE':
      input.answer = new Array ('FALSE', 'TRUE');
      break;
    case '0':
    case '1':
    default:
      input.answer = new Array ('0', '1');
      break;
    }
    value = value.toUpperCase ();
    input.checked = ((value == '0') || (value == "NO") || (value == "FALSE")) ? false : true;
    input.title = 'On/Off value';
    break;
  case 'integer':
    input.size = 10;
    input.title = 'Integer value';
    input.regexp = /^[0-9]*$/;
    break;
  case 'float':
    input.size = 12;
    input.title = 'Floting point value';
    input.regexp = /^[0-9e.+-]*$/i;
    break;
  case 'ip':
    input.size = 15;
    input.title = 'IP address';
    input.regexp = /^[0-9.]*$/;
    break;
  case 'mac':
    input.size = 17;
    input.title = 'MAC address';
    input.regexp = /^([0-9A-F]{2}[:]){5}([0-9A-F]{2})$/i;
    break;
  case 'string':
  default:
    input.size = 255;
    input.title = 'String value';
   break;
  }
  if (default_value.length != 0)
    input.title += ' (default value ' + default_value + ')';
  input.id = variable;
  add_event (input, 'input', check_input);

  return input;
}

/* get input value */

function get_input_value (input) {

  if ((typeof input === 'undefined') || (typeof input.value === 'undefined'))
    return '';
  if (typeof input.answer !== 'undefined')
    return input.answer[input.checked ? 1 : 0];

  return input.value;
}
