/* -*- Javascript -*- */

var menu = new Array ();

/* callback structure */

function menuCallback (label, enable, func) {
  return { label: label, enable: enable, func: func };
}

/* get event position */

function get_event_position (e) {
  var pos = { x: 0, y: 0 };

  /* find coordinates */
  if (e.pageX == null) {
    /* IE case */
    var d= (document.documentElement &&
            document.documentElement.scrollLeft != null) ?
      document.documentElement : document.body;
    pos.x = e.clientX + d.scrollLeft;
    pos.y = e.clientY + d.scrollTop;
  } else {
    /* all other browsers */
    pos.x = e.pageX;
    pos.y = e.pageY;
  }

  return pos;
}

/* hide menu function */

function hide_menu () {

  /* hide and empty menu */
  var ref = document.getElementById ('menu');
  ref.style.visibility = 'hidden';
  ref.innerHTML = '';

}

/* show menu function */

function show_menu (e, id) {

  update_status ('', 0);

  /* get event position */
  var pos = get_event_position (e);

  /* count remaining items */
  var nb = 0;
  for (var i = 0; i < nb_items; i++)
    if (document.getElementById ('var_' + i))
      nb++;

  /* update menu */
  var ref = document.getElementById ('menu');
  var buffer = '<dl>\n';
  for (var i = 0;  i < menu.length; i++) {
    buffer += '<dt ';
    if ((menu[i].enable == null) || (menu[i].enable (id)))
      buffer +=  'onclick="javascript:do_menu_func (' + i + ', ' + id + ');"';
    else
      buffer +=  'class="disabled"';
    buffer += '>' + menu[i].label + '</dt>\n';
  }
  buffer += '</dl>\n';
  ref.innerHTML = buffer;

  /* move and show menu */
  ref.style.left = pos.x + 'px';
  ref.style.top  = pos.y + 'px';
  ref.style.visibility = 'visible';

}

/* menu action */

function do_menu_func (i, id) {

  /* menu callnack */

  var res = menu[i].func (id);
  var msg = (typeof res.msg !== 'undefined') ? res.msg : '';
  var stat = (typeof res.stat !== 'undefined') ? res.stat : 0;

  /* hide menu and update statut */

  hide_menu ();
  update_status (msg, stat);

}
